---
title: Xamarin.Android error/warning ADB0000
description: ADB0000 error/warning code
ms.date: 07/04/2018
---
# Xamarin.Android error/warning ADB0000

## Example messages

```
error ADB0000: error: no devices/emulators found
```

## Issue

This message indicates that `adb` (Android Debug Bridge) reported an
unhandled/unexpected error or warning. `adb` is part of the Android
SDK and is used internally by Xamarin.Android to communicate with
Android emulators and devices.

## Solution

To learn more about `adb`, see the [Android documentation][adb].

Errors reported by `adb` are outside of Xamarin.Android's
control, so a general error code of ADB0000 is used for unexpected
errors reporting the exact message coming from `adb`.

[adb]: https://developer.android.com/studio/command-line/adb

## Implementation notes

Note that nothing in the open source xamarin-android repository
emits ADB0000, as features such as debugging and "fast deployment"
are implemented in the proprietary Xamarin.Android additions.
